// JavaScript Code for MasterMind widget
// copyright 2005
// by Darrel Raines
// of Sirius Consultants, Inc.

  //Variable Assignment
  var colorBox = new Array();
  var marble = new Array();
  var label = new Array();
  var board = new Array();
  var key = new Array();
  var guess = new Array();
  var face = new Image();
  var stats1 = new Text();
  var stats2 = new Text();
  var stats3 = new Text();
  var cMenu = new Array();
  var gameOver = false; //Game is in progress.
  var currentColor = 1; //Point to the default color box.
  var currentRound = 1; //Point to the default row of marbles.
  
  //Populate the color boxes with marbles of various shades and label them.
  for (var i = 0; i < 6; i++) {
    colorBox[i] = new Image();
    marble[i] = new Image();
    colorBox[i].src = "Resources/box.png";
    colorBox[i].hOffset = 200;
    colorBox[i].vOffset = 70 + (i*30);
    colorBox[i].hAlign = "center";
    colorBox[i].vAlign = "center";
    colorBox[i].onMouseUp = "changeColor(" + (i+1) +");";
    colorBox[i].tooltip = "Select as the current color.";
    marble[i].src = "Resources/marble.png";
    marble[i].hOffset = 200;
    marble[i].vOffset = 70 + (i*30);
    marble[i].vAlign = "center";
    marble[i].hAlign = "center";
    marble[i].colorize = getMarbleColor(i + 1);
    label[i] = new Text();
    label[i].data = i + 1;
    label[i].hOffset = 182;
    label[i].vOffset = 74 + (i*30);
    label[i].alignment = "center";
  }

  //Initialize the playing board surface for the first game.
  for (i = 0; i < 10; i++) {
    board[i] = new Array();
    for (var j = 0; j < 4; j++) {
      board[i][j] = new Image();
      board[i][j].src = "Resources/hole.png";
      board[i][j].hOffset = 33 + (j*23);
      board[i][j].vOffset = 290 - (i*23);
      board[i][j].hAlign = "center";
      board[i][j].vAlign = "center";
    }
    for (j = 4; j< 8; j++) {
      board[i][j] = new Image();
      board[i][j].src = "Resources/peg.png";
      board[i][j].hOffset = 66 + (j*14);
      board[i][j].vOffset = 290 - (i*23);
      board[i][j].hAlign = "center";
      board[i][j].vAlign = "center";
      board[i][j].opacity = 120;
    }
  }
  
  //Set up the face (result indicator) image for later use.
  face.src = "Resources/happy face.png";
  face.opacity = 0;
  face.hOffset = 180;
  face.vOffset = 290;
  
  //Set up the Statistics display.
  stats1.data = "Stats:";
  stats1.hOffset = 180;
  stats1.vOffset = 250;
  stats2.data = "R 1";
  stats2.hOffset = 180;
  stats2.vOffset = 264;
  stats3.hOffset = 180;
  stats3.vOffset = 278;
  updateStats(true);

  //Set up the initial key code. This will not be used in an actual game.
  key[0] = 0;
  key[1] = 0;
  key[2] = 0;
  key[3] = 0;
  key[4] = new Image();
  key[4].src = "Resources/marble.png";
  key[4].hOffset = 33;
  key[4].vOffset = 315;
  key[4].hAlign = "center";
  key[4].vAlign = "center";
  key[4].opacity = 0;
  key[5] = new Image();
  key[5].src = "Resources/marble.png";
  key[5].hOffset = 56;
  key[5].vOffset = 315;
  key[5].hAlign = "center";
  key[5].vAlign = "center";
  key[5].opacity = 0;
  key[6] = new Image();
  key[6].src = "Resources/marble.png";
  key[6].hOffset = 79;
  key[6].vOffset = 315;
  key[6].hAlign = "center";
  key[6].vAlign = "center";
  key[6].opacity = 0;
  key[7] = new Image();
  key[7].src = "Resources/marble.png";
  key[7].hOffset = 102;
  key[7].vOffset = 315;
  key[7].hAlign = "center";
  key[7].vAlign = "center";
  key[7].opacity = 0;
  
  //Set up the context menus for both windows.
  cMenu[0] = new MenuItem();
  cMenu[0].title = "Help";
  cMenu[0].checked = false;
  cMenu[0].onSelect = "viewHelp();"
  masterMind.contextMenuItems = cMenu;
  masterMindHelp.contextMenuItems = cMenu;

  //Initialize any other elements.
  changeColor(currentColor);
  activate(currentRound);
  changePrefs();
  masterMind.visible = true;
  newKey();
  guess[0] = -1;
  guess[1] = -1;
  guess[2] = -1;
  guess[3] = -1;
  help.data = filesystem.readFile("MasterMind.txt");
  
  //End of the "onLoad" routine.
  
  //Start a new game of MasterMind.
  function quitGame() {
    if (gameOver == false) {
      var answer = alert("Are you sure you want to quit the current game (and lose)?", "Yes", "No");
      if (answer == 1) {
        gameOver = true;
        deactivate(currentRound);
        currentRound = 10;
        stats2.data = "R " + currentRound;
        for (i = 4; i < 8; i++) {
          key[i].opacity = 255;
        }
        title.tooltip = "Start a new game.";
        face.src = "Resources/sad face.png";
        face.opacity = 255;
        updateStats(false);
      } else {
        return;
      }
    } else {
      newKey();
      resetBoard();
      currentRound = 1;
      stats2.data = "R " + currentRound;
      activate(currentRound);
      title.tooltip = "Quit current game.";
    }
  }
  
  //Handle any key press. Number keys will select different marble colors.
  function handleKey() {
    var keyPressed = Number(system.event.key);
    if ((keyPressed >= 1) && (keyPressed <= 6)) {
      changeColor(keyPressed);
    }
  }

  //Handle a user-initiated change of preferences.
  function changePrefs() {
    if (preferences.glow.value == 0) {
      table.clipRect = "12, 9, 212, 266"
    } else {
      table.clipRect = "";
    }
    if (preferences.showBrain.value == 0) {
      brain.opacity = 0;
    } else {
      brain.opacity = 255;
      if (preferences.brainDefault.value == 0) {
        brain.colorize = preferences.brainColor.value;
      } else {
        brain.colorize = "";
      }
    }
    if (preferences.boardDefault.value == 0) {
      table.colorize = preferences.boardColor.value;
    } else {
      table.colorize = "";
    }
    title.font = preferences.titleFont.value;
    title.size = 24 + Number(preferences.titleSize.value);
    title.color = preferences.titleColor.value;
    for (var i = 0; i < 6; i++) {
      label[i].font = preferences.textFont.value;
      label[i].size = 12 + Number(preferences.textSize.value);
      label[i].color = preferences.textColor.value;
    }
    stats1.font = preferences.textFont.value;
    stats1.size = 12 + Number(preferences.textSize.value);
    stats1.color = preferences.textColor.value;
    stats2.font = preferences.textFont.value;
    stats2.size = 12 + Number(preferences.textSize.value);
    stats2.color = preferences.textColor.value;
    stats3.font = preferences.textFont.value;
    stats3.size = 12 + Number(preferences.textSize.value);
    stats3.color = preferences.textColor.value;
  }

  //Change the currently selected marble.
  function changeColor(newColor) {
    colorBox[currentColor - 1].colorize = "";
    currentColor = newColor;
    colorBox[currentColor - 1].colorize = "#9933CC"
  }
  
  //Put a colored marble in the current hole.
  function placeMarble(holePosition) {
    board[currentRound - 1][holePosition - 1].src = "Resources/marble.png";
    board[currentRound - 1][holePosition - 1].colorize = getMarbleColor(currentColor);
    guess[holePosition - 1] = currentColor - 1;
  }
  
  //Get the color of the currently selected marble.
  function getMarbleColor(marblePosition) {
    switch (marblePosition) {
      case 1:
        return "#FF0000";
      case 2:
        return "#0000FF";
      case 3:
        return "#00FF00";
      case 4:
        return "#FFFF00";
      case 5:
        return "#FFFFFF";
      case 6:
      default:
        return "#000000";
    }
  }

  //De-activate a row of marble holes for mouse effects.
  function deactivate(row) {
    for (var i = 0; i < 4; i++) {
      board[row - 1][i].onMouseUp = "";
      board[row - 1][i].tooltip = "";
    }
    board[row - 1][4].onMouseUp = "";
    board[row - 1][4].tooltip = "";
  }
  
  //Activate a row of marble holes for mouse effects.
  function activate(row) {
    for (var i = 0; i < 4; i++) {
      board[row - 1][i].onMouseUp = "placeMarble(" + (i+1) + ");";
      board[row - 1][i].tooltip = "Place colored marble here.";
    }
    board[row - 1][4].onMouseUp = "scoreRound();";
    board[row - 1][4].tooltip = "Score the current guess.";
  }
  
  //Score the current guess and show the results.
  function scoreRound() {
    var completeGuess = true;
    for (var i = 0; i < 4; i++) {
      if (board[currentRound - 1][i].src == "Resources/hole.png") {
        completeGuess = false;
      }
    }
    if (completeGuess == true) { //A complete set of four marbles.
      deactivate(currentRound);
      gameOver = placePegs();
      if (gameOver == false) { //No winner.
        if (currentRound == 10) { //Out of rounds, we have a loser.
          gameOver = true;
          title.tooltip = "Start a new game.";
          for (i = 4; i < 8; i++) {
            key[i].opacity = 255;
          }
          face.src = "Resources/sad face.png";
          face.opacity = 255;
          updateStats(false);
        } else { //Play next round.
          currentRound++;
          stats2.data = "R " + currentRound;
          activate(currentRound);
        }
      } else { //We have a winner.
        title.tooltip = "Start a new game.";
        for (i = 4; i < 8; i++) {
          key[i].opacity = 255;
        }
        if (currentRound >= 6) {
          face.src = "Resources/surprise face.png";
        } else {
          face.src = "Resources/happy face.png";
        }
        face.opacity = 255;
        updateStats(false);
      }
    } else { //Not a complete set of four marbles.
      alert("Please enter a marble in every hole.", "Okay");
    }
  }

  //Count the white/black peg conditions and place the pegs. Return a true
  //condition if the guess was correct; otherwise, return a false condition.
  function placePegs() {
    var testKey = new Array();
    var pegPosition = 4;
    for (var i = 0; i < 4; i++) {
      testKey[i] = key[i];
      if (testKey[i] == guess[i]) {
        testKey[i] = -2; //Safe value.
        guess[i] = -1; //Safe value.
        board[currentRound - 1][pegPosition].colorize = "#000000";
        board[currentRound - 1][pegPosition].opacity = 255;
        pegPosition++;
      }
    }
    if (pegPosition == 8) return true;
    for (i = 0; i < 4; i++) {
      for (var j = 0; j < 4; j++) {
        if (testKey[j] == guess[i]) {
          testKey[j] = -2; //Safe value.
          guess[i] = -1; //Safe value.
          board[currentRound - 1][pegPosition].colorize = "#FFFFFF";
          board[currentRound - 1][pegPosition].opacity = 255;
          pegPosition++;
        }
      }
    }
    return false;
  }

  //Pick a random marble color.
  function randomMarble() {
    return Math.floor(Math.random() * 6);
  }

  //Create a random sequence of four color marbles.
  function newKey() {
    for (var i = 0; i < 4; i++) {
      key[i] = randomMarble();
    }
    for (i = 4; i < 8; i++) {
      key[i].colorize = getMarbleColor(key[i - 4] + 1);
      key[i].opacity = 0;
    }
  }

  //Reset the playing board surface for the next game.
  function resetBoard() {
    for (i = 0; i < 10; i++) {
      for (var j = 0; j < 4; j++) {
        board[i][j].src = "Resources/hole.png";
      }
      for (j = 4; j< 8; j++) {
        board[i][j].src = "Resources/peg.png";
        board[i][j].colorize = "";
        board[i][j].opacity = 120;
      }
    }
    face.opacity = 0;
  }

  //Update the game statistics with the results of the last game. The display
  //input flag determines whether the current game should be counted or not.
  function updateStats(displayOnly) {
    if (!displayOnly) {
      preferences.numberGames.value = Number(preferences.numberGames.value) + 1;
      preferences.numberRounds.value = currentRound + Number(preferences.numberRounds.value);
    }
    if (preferences.numberGames.value > 0) {
      stats3.data = "A " + (Math.round(Number(preferences.numberRounds.value)/Number(preferences.numberGames.value)*100)/100);
    } else {
      stats3.data = "A ?";
    }
  }

  //Toggle visibility of the Help window and check the context menu item.
  function viewHelp() {
    if (masterMindHelp.visible == false) {
      masterMindHelp.visible = true;
      cMenu[0].checked = true;
    } else {
      masterMindHelp.visible = false;
      cMenu[0].checked = false;
    }
  }
